test-lib.sh: A command dying due to a signal is an unexpected failure.
[git/git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset AUTHOR_DATE
15 unset AUTHOR_EMAIL
16 unset AUTHOR_NAME
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20 unset GIT_AUTHOR_DATE
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
26 unset GIT_DIFF_OPTS
27 unset GIT_DIR
28 unset GIT_EXTERNAL_DIFF
29 unset GIT_INDEX_FILE
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
33 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
34 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35 export EDITOR VISUAL
36
37 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
38 1|2|true)
39 echo "* warning: Some tests will not work if GIT_TRACE" \
40 "is set as to trace on STDERR ! *"
41 echo "* warning: Please set GIT_TRACE to something" \
42 "other than 1, 2 or true ! *"
43 ;;
44 esac
45
46 # Each test should start with something like this, after copyright notices:
47 #
48 # test_description='Description of this test...
49 # This test checks if command xyzzy does the right thing...
50 # '
51 # . ./test-lib.sh
52
53 error () {
54 echo "* error: $*"
55 trap - exit
56 exit 1
57 }
58
59 say () {
60 echo "* $*"
61 }
62
63 test "${test_description}" != "" ||
64 error "Test script did not set test_description."
65
66 while test "$#" -ne 0
67 do
68 case "$1" in
69 -d|--d|--de|--deb|--debu|--debug)
70 debug=t; shift ;;
71 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
72 immediate=t; shift ;;
73 -h|--h|--he|--hel|--help)
74 echo "$test_description"
75 exit 0 ;;
76 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
77 verbose=t; shift ;;
78 --no-python)
79 no_python=t; shift ;;
80 *)
81 break ;;
82 esac
83 done
84
85 exec 5>&1
86 if test "$verbose" = "t"
87 then
88 exec 4>&2 3>&1
89 else
90 exec 4>/dev/null 3>/dev/null
91 fi
92
93 test_failure=0
94 test_count=0
95
96 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
97
98
99 # You are not expected to call test_ok_ and test_failure_ directly, use
100 # the text_expect_* functions instead.
101
102 test_ok_ () {
103 test_count=$(expr "$test_count" + 1)
104 say " ok $test_count: $@"
105 }
106
107 test_failure_ () {
108 test_count=$(expr "$test_count" + 1)
109 test_failure=$(expr "$test_failure" + 1);
110 say "FAIL $test_count: $1"
111 shift
112 echo "$@" | sed -e 's/^/ /'
113 test "$immediate" = "" || { trap - exit; exit 1; }
114 }
115
116
117 test_debug () {
118 test "$debug" = "" || eval "$1"
119 }
120
121 test_run_ () {
122 eval >&3 2>&4 "$1"
123 eval_ret="$?"
124 return 0
125 }
126
127 test_expect_failure () {
128 test "$#" = 2 ||
129 error "bug in the test script: not 2 parameters to test-expect-failure"
130 say >&3 "expecting failure: $2"
131 test_run_ "$2"
132 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
133 then
134 test_ok_ "$1"
135 else
136 test_failure_ "$@"
137 fi
138 echo >&3 ""
139 }
140
141 test_expect_success () {
142 test "$#" = 2 ||
143 error "bug in the test script: not 2 parameters to test-expect-success"
144 say >&3 "expecting success: $2"
145 test_run_ "$2"
146 if [ "$?" = 0 -a "$eval_ret" = 0 ]
147 then
148 test_ok_ "$1"
149 else
150 test_failure_ "$@"
151 fi
152 echo >&3 ""
153 }
154
155 test_expect_code () {
156 test "$#" = 3 ||
157 error "bug in the test script: not 3 parameters to test-expect-code"
158 say >&3 "expecting exit code $1: $3"
159 test_run_ "$3"
160 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
161 then
162 test_ok_ "$2"
163 else
164 test_failure_ "$@"
165 fi
166 echo >&3 ""
167 }
168
169 # Most tests can use the created repository, but some amy need to create more.
170 # Usage: test_create_repo <directory>
171 test_create_repo () {
172 test "$#" = 1 ||
173 error "bug in the test script: not 1 parameter to test-create-repo"
174 owd=`pwd`
175 repo="$1"
176 mkdir "$repo"
177 cd "$repo" || error "Cannot setup test environment"
178 "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
179 error "cannot run git init-db -- have you built things yet?"
180 mv .git/hooks .git/hooks-disabled
181 cd "$owd"
182 }
183
184 test_done () {
185 trap - exit
186 case "$test_failure" in
187 0)
188 # We could:
189 # cd .. && rm -fr trash
190 # but that means we forbid any tests that use their own
191 # subdirectory from calling test_done without coming back
192 # to where they started from.
193 # The Makefile provided will clean this test area so
194 # we will leave things as they are.
195
196 say "passed all $test_count test(s)"
197 exit 0 ;;
198
199 *)
200 say "failed $test_failure among $test_count test(s)"
201 exit 1 ;;
202
203 esac
204 }
205
206 # Test the binaries we have just built. The tests are kept in
207 # t/ subdirectory and are run in trash subdirectory.
208 PATH=$(pwd)/..:$PATH
209 GIT_EXEC_PATH=$(pwd)/..
210 HOME=$(pwd)/trash
211 export PATH GIT_EXEC_PATH HOME
212
213 # Similarly use ../compat/subprocess.py if our python does not
214 # have subprocess.py on its own.
215 PYTHON=`sed -e '1{
216 s/^#!//
217 q
218 }' ../git-merge-recursive-old` || {
219 error "You haven't built things yet, have you?"
220 }
221 "$PYTHON" -c 'import subprocess' 2>/dev/null || {
222 PYTHONPATH=$(pwd)/../compat
223 export PYTHONPATH
224 }
225 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
226 export GITPERLLIB
227 test -d ../templates/blt || {
228 error "You haven't built things yet, have you?"
229 }
230
231 # Test repository
232 test=trash
233 rm -fr "$test"
234 test_create_repo $test
235 cd "$test"